﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;

namespace Tooska
{

    public enum FontAwesomeIcons
    {
        _500px,
        AddressBook,
        AddressBookO,
        AddressCard,
        AddressCardO,
        Adjust,
        Adn,
        AlignCenter,
        AlignJustify,
        AlignLeft,
        AlignRight,
        Amazon,
        Ambulance,
        AmericanSignLanguageInterpreting,
        Anchor,
        Android,
        Angellist,
        AngleDoubleDown,
        AngleDoubleLeft,
        AngleDoubleRight,
        AngleDoubleUp,
        AngleDown,
        AngleLeft,
        AngleRight,
        AngleUp,
        Apple,
        Archive,
        AreaChart,
        ArrowCircleDown,
        ArrowCircleLeft,
        ArrowCircleODown,
        ArrowCircleOLeft,
        ArrowCircleORight,
        ArrowCircleOUp,
        ArrowCircleRight,
        ArrowCircleUp,
        ArrowDown,
        ArrowLeft,
        ArrowRight,
        Arrows,
        ArrowsAlt,
        ArrowsH,
        ArrowsV,
        ArrowUp,
        AslInterpreting,
        AssistiveListeningSystems,
        Asterisk,
        At,
        AudioDescription,
        Automobile,
        Backward,
        BalanceScale,
        Ban,
        Bandcamp,
        Bank,
        BarChart,
        BarChartO,
        Barcode,
        Bars,
        Bath,
        Bathtub,
        Battery,
        Battery0,
        Battery1,
        Battery2,
        Battery3,
        Battery4,
        BatteryEmpty,
        BatteryFull,
        BatteryHalf,
        BatteryQuarter,
        BatteryThreeQuarters,
        Bed,
        Beer,
        Behance,
        BehanceSquare,
        Bell,
        BellO,
        BellSlash,
        BellSlashO,
        Bicycle,
        Binoculars,
        BirthdayCake,
        Bitbucket,
        BitbucketSquare,
        Bitcoin,
        BlackTie,
        Blind,
        Bluetooth,
        BluetoothB,
        Bold,
        Bolt,
        Bomb,
        Book,
        Bookmark,
        BookmarkO,
        Braille,
        Briefcase,
        Btc,
        Bug,
        Building,
        BuildingO,
        Bullhorn,
        Bullseye,
        Bus,
        Buysellads,
        Cab,
        Calculator,
        Calendar,
        CalendarCheckO,
        CalendarMinusO,
        CalendarO,
        CalendarPlusO,
        CalendarTimesO,
        Camera,
        CameraRetro,
        Car,
        CaretDown,
        CaretLeft,
        CaretRight,
        CaretSquareODown,
        CaretSquareOLeft,
        CaretSquareORight,
        CaretSquareOUp,
        CaretUp,
        CartArrowDown,
        CartPlus,
        Cc,
        CcAmex,
        CcDinersClub,
        CcDiscover,
        CcJcb,
        CcMastercard,
        CcPaypal,
        CcStripe,
        CcVisa,
        Certificate,
        Chain,
        ChainBroken,
        Check,
        CheckCircle,
        CheckCircleO,
        CheckSquare,
        CheckSquareO,
        ChevronCircleDown,
        ChevronCircleLeft,
        ChevronCircleRight,
        ChevronCircleUp,
        ChevronDown,
        ChevronLeft,
        ChevronRight,
        ChevronUp,
        Child,
        Chrome,
        Circle,
        CircleO,
        CircleONotch,
        CircleThin,
        Clipboard,
        ClockO,
        Clone,
        Close,
        Cloud,
        CloudDownload,
        CloudUpload,
        Cny,
        Code,
        CodeFork,
        Codepen,
        Codiepie,
        Coffee,
        Cog,
        Cogs,
        Columns,
        Comment,
        Commenting,
        CommentingO,
        CommentO,
        Comments,
        CommentsO,
        Compass,
        Compress,
        Connectdevelop,
        Contao,
        Copy,
        Copyright,
        CreativeCommons,
        CreditCard,
        CreditCardAlt,
        Crop,
        Crosshairs,
        Css3,
        Cube,
        Cubes,
        Cut,
        Cutlery,
        Dashboard,
        Dashcube,
        Database,
        Deaf,
        Deafness,
        Dedent,
        Delicious,
        Desktop,
        Deviantart,
        Diamond,
        Digg,
        Dollar,
        DotCircleO,
        Download,
        Dribbble,
        DriversLicense,
        DriversLicenseO,
        Dropbox,
        Drupal,
        Edge,
        Edit,
        Eercast,
        Eject,
        EllipsisH,
        EllipsisV,
        Empire,
        Envelope,
        EnvelopeO,
        EnvelopeOpen,
        EnvelopeOpenO,
        EnvelopeSquare,
        Envira,
        Eraser,
        Etsy,
        Eur,
        Euro,
        Exchange,
        Exclamation,
        ExclamationCircle,
        ExclamationTriangle,
        Expand,
        Expeditedssl,
        ExternalLink,
        ExternalLinkSquare,
        Eye,
        Eyedropper,
        EyeSlash,
        Fa,
        Facebook,
        FacebookF,
        FacebookOfficial,
        FacebookSquare,
        FastBackward,
        FastForward,
        Fax,
        Feed,
        Female,
        FighterJet,
        File,
        FileArchiveO,
        FileAudioO,
        FileCodeO,
        FileExcelO,
        FileImageO,
        FileMovieO,
        FileO,
        FilePdfO,
        FilePhotoO,
        FilePictureO,
        FilePowerpointO,
        FilesO,
        FileSoundO,
        FileText,
        FileTextO,
        FileVideoO,
        FileWordO,
        FileZipO,
        Film,
        Filter,
        Fire,
        FireExtinguisher,
        Firefox,
        FirstOrder,
        Flag,
        FlagCheckered,
        FlagO,
        Flash,
        Flask,
        Flickr,
        FloppyO,
        Folder,
        FolderO,
        FolderOpen,
        FolderOpenO,
        Font,
        FontAwesome,
        Fonticons,
        FortAwesome,
        Forumbee,
        Forward,
        Foursquare,
        FreeCodeCamp,
        FrownO,
        FutbolO,
        Gamepad,
        Gavel,
        Gbp,
        Ge,
        Gear,
        Gears,
        Genderless,
        GetPocket,
        Gg,
        GgCircle,
        Gift,
        Git,
        Github,
        GithubAlt,
        GithubSquare,
        Gitlab,
        GitSquare,
        Gittip,
        Glass,
        Glide,
        GlideG,
        Globe,
        Google,
        GooglePlus,
        GooglePlusCircle,
        GooglePlusOfficial,
        GooglePlusSquare,
        GoogleWallet,
        GraduationCap,
        Gratipay,
        Grav,
        Group,
        HackerNews,
        HandGrabO,
        HandLizardO,
        HandODown,
        HandOLeft,
        HandORight,
        HandOUp,
        HandPaperO,
        HandPeaceO,
        HandPointerO,
        HandRockO,
        HandScissorsO,
        HandshakeO,
        HandSpockO,
        HandStopO,
        HardOfHearing,
        Hashtag,
        HddO,
        Header,
        Headphones,
        Heart,
        Heartbeat,
        HeartO,
        History,
        Home,
        HospitalO,
        Hotel,
        Hourglass,
        Hourglass1,
        Hourglass2,
        Hourglass3,
        HourglassEnd,
        HourglassHalf,
        HourglassO,
        HourglassStart,
        Houzz,
        HSquare,
        Html5,
        ICursor,
        IdBadge,
        IdCard,
        IdCardO,
        Ils,
        Image,
        Imdb,
        Inbox,
        Indent,
        Industry,
        Info,
        InfoCircle,
        Inr,
        Instagram,
        Institution,
        InternetExplorer,
        Intersex,
        Ioxhost,
        Italic,
        Joomla,
        Jpy,
        Jsfiddle,
        Key,
        KeyboardO,
        Krw,
        Language,
        Laptop,
        Lastfm,
        LastfmSquare,
        Leaf,
        Leanpub,
        Legal,
        LemonO,
        LevelDown,
        LevelUp,
        LifeBouy,
        LifeBuoy,
        LifeRing,
        LifeSaver,
        LightbulbO,
        LineChart,
        Link,
        Linkedin,
        LinkedinSquare,
        Linode,
        Linux,
        List,
        ListAlt,
        ListOl,
        ListUl,
        LocationArrow,
        Lock,
        LongArrowDown,
        LongArrowLeft,
        LongArrowRight,
        LongArrowUp,
        LowVision,
        Magic,
        Magnet,
        MailForward,
        MailReply,
        MailReplyAll,
        Male,
        Map,
        MapMarker,
        MapO,
        MapPin,
        MapSigns,
        Mars,
        MarsDouble,
        MarsStroke,
        MarsStrokeH,
        MarsStrokeV,
        Maxcdn,
        Meanpath,
        Medium,
        Medkit,
        Meetup,
        MehO,
        Mercury,
        Microchip,
        Microphone,
        MicrophoneSlash,
        Minus,
        MinusCircle,
        MinusSquare,
        MinusSquareO,
        Mixcloud,
        Mobile,
        MobilePhone,
        Modx,
        Money,
        MoonO,
        MortarBoard,
        Motorcycle,
        MousePointer,
        Music,
        Navicon,
        Neuter,
        NewspaperO,
        ObjectGroup,
        ObjectUngroup,
        Odnoklassniki,
        OdnoklassnikiSquare,
        Opencart,
        Openid,
        Opera,
        OptinMonster,
        Outdent,
        Pagelines,
        PaintBrush,
        Paperclip,
        PaperPlane,
        PaperPlaneO,
        Paragraph,
        Paste,
        Pause,
        PauseCircle,
        PauseCircleO,
        Paw,
        Paypal,
        Pencil,
        PencilSquare,
        PencilSquareO,
        Percent,
        Phone,
        PhoneSquare,
        Photo,
        PictureO,
        PieChart,
        PiedPiper,
        PiedPiperAlt,
        PiedPiperPp,
        Pinterest,
        PinterestP,
        PinterestSquare,
        Plane,
        Play,
        PlayCircle,
        PlayCircleO,
        Plug,
        Plus,
        PlusCircle,
        PlusSquare,
        PlusSquareO,
        Podcast,
        PowerOff,
        Print,
        ProductHunt,
        PuzzlePiece,
        Qq,
        Qrcode,
        Question,
        QuestionCircle,
        QuestionCircleO,
        Quora,
        QuoteLeft,
        QuoteRight,
        Ra,
        Random,
        Ravelry,
        Rebel,
        Recycle,
        Reddit,
        RedditAlien,
        RedditSquare,
        Refresh,
        Registered,
        Remove,
        Renren,
        Reorder,
        Repeat,
        Reply,
        ReplyAll,
        Resistance,
        Retweet,
        Rmb,
        Road,
        Rocket,
        RotateLeft,
        RotateRight,
        Rouble,
        Rss,
        RssSquare,
        Rub,
        Ruble,
        Rupee,
        S15,
        Safari,
        Save,
        Scissors,
        Scribd,
        Search,
        SearchMinus,
        SearchPlus,
        Sellsy,
        Send,
        SendO,
        Server,
        Share,
        ShareAlt,
        ShareAltSquare,
        ShareSquare,
        ShareSquareO,
        Shekel,
        Sheqel,
        Shield,
        Ship,
        Shirtsinbulk,
        ShoppingBag,
        ShoppingBasket,
        ShoppingCart,
        Shower,
        Signal,
        SignIn,
        Signing,
        SignLanguage,
        SignOut,
        Simplybuilt,
        Sitemap,
        Skyatlas,
        Skype,
        Slack,
        Sliders,
        Slideshare,
        SmileO,
        Snapchat,
        SnapchatGhost,
        SnapchatSquare,
        SnowflakeO,
        SoccerBallO,
        Sort,
        SortAlphaAsc,
        SortAlphaDesc,
        SortAmountAsc,
        SortAmountDesc,
        SortAsc,
        SortDesc,
        SortDown,
        SortNumericAsc,
        SortNumericDesc,
        SortUp,
        Soundcloud,
        SpaceShuttle,
        Spinner,
        Spoon,
        Spotify,
        Square,
        SquareO,
        StackExchange,
        StackOverflow,
        Star,
        StarHalf,
        StarHalfEmpty,
        StarHalfFull,
        StarHalfO,
        StarO,
        Steam,
        SteamSquare,
        StepBackward,
        StepForward,
        Stethoscope,
        StickyNote,
        StickyNoteO,
        Stop,
        StopCircle,
        StopCircleO,
        StreetView,
        Strikethrough,
        Stumbleupon,
        StumbleuponCircle,
        Subscript,
        Subway,
        Suitcase,
        SunO,
        Superpowers,
        Superscript,
        Support,
        Table,
        Tablet,
        Tachometer,
        Tag,
        Tags,
        Tasks,
        Taxi,
        Telegram,
        Television,
        TencentWeibo,
        Terminal,
        TextHeight,
        TextWidth,
        Th,
        Themeisle,
        Thermometer,
        Thermometer0,
        Thermometer1,
        Thermometer2,
        Thermometer3,
        Thermometer4,
        ThermometerEmpty,
        ThermometerFull,
        ThermometerHalf,
        ThermometerQuarter,
        ThermometerThreeQuarters,
        ThLarge,
        ThList,
        ThumbsDown,
        ThumbsODown,
        ThumbsOUp,
        ThumbsUp,
        ThumbTack,
        Ticket,
        Times,
        TimesCircle,
        TimesCircleO,
        TimesRectangle,
        TimesRectangleO,
        Tint,
        ToggleDown,
        ToggleLeft,
        ToggleOff,
        ToggleOn,
        ToggleRight,
        ToggleUp,
        Trademark,
        Train,
        Transgender,
        TransgenderAlt,
        Trash,
        TrashO,
        Tree,
        Trello,
        Tripadvisor,
        Trophy,
        Truck,
        Try,
        Tty,
        Tumblr,
        TumblrSquare,
        TurkishLira,
        Tv,
        Twitch,
        Twitter,
        TwitterSquare,
        Umbrella,
        Underline,
        Undo,
        UniversalAccess,
        University,
        Unlink,
        Unlock,
        UnlockAlt,
        Unsorted,
        Upload,
        Usb,
        Usd,
        User,
        UserCircle,
        UserCircleO,
        UserMd,
        UserO,
        UserPlus,
        Users,
        UserSecret,
        UserTimes,
        Vcard,
        VcardO,
        Venus,
        VenusDouble,
        VenusMars,
        Viacoin,
        Viadeo,
        ViadeoSquare,
        VideoCamera,
        Vimeo,
        VimeoSquare,
        Vine,
        Vk,
        VolumeControlPhone,
        VolumeDown,
        VolumeOff,
        VolumeUp,
        Warning,
        Wechat,
        Weibo,
        Weixin,
        Whatsapp,
        Wheelchair,
        WheelchairAlt,
        Wifi,
        WikipediaW,
        WindowClose,
        WindowCloseO,
        WindowMaximize,
        WindowMinimize,
        WindowRestore,
        Windows,
        Won,
        Wordpress,
        Wpbeginner,
        Wpexplorer,
        Wpforms,
        Wrench,
        Xing,
        XingSquare,
        Yahoo,
        Yc,
        YCombinator,
        YCombinatorSquare,
        YcSquare,
        Yelp,
        Yen,
        Yoast,
        Youtube,
        YoutubePlay,
        YoutubeSquare
    }

    public enum Glyphicons
    {
        Asterisk,
        Plus,
        Euro,
        Minus,
        Cloud,
        Envelope,
        Pencil,
        Glass,
        Music,
        Search,
        Heart,
        Star,
        StarEmpty,
        User,
        Film,
        ThLarge,
        Th,
        ThList,
        Ok,
        Remove,
        ZoomIn,
        ZoomOut,
        Off,
        Signal,
        Cog,
        Trash,
        Home,
        File,
        Time,
        Road,
        DownloadAlt,
        Download,
        Upload,
        Inbox,
        PlayCircle,
        Repeat,
        Refresh,
        ListAlt,
        Flag,
        Headphones,
        VolumeOff,
        VolumeDown,
        VolumeUp,
        Qrcode,
        Barcode,
        Tag,
        Tags,
        Book,
        Print,
        Font,
        Bold,
        Italic,
        TextHeight,
        TextWidth,
        AlignLeft,
        AlignCenter,
        AlignRight,
        AlignJustify,
        List,
        IndentLeft,
        IndentRight,
        FacetimeVideo,
        Picture,
        MapMarker,
        Adjust,
        Tint,
        Edit,
        Share,
        Check,
        Move,
        StepBackward,
        FastBackward,
        Backward,
        Play,
        Pause,
        Stop,
        Forward,
        FastForward,
        StepForward,
        Eject,
        ChevronLeft,
        ChevronRight,
        PlusSign,
        MinusSign,
        RemoveSign,
        OkSign,
        QuestionSign,
        InfoSign,
        Screenshot,
        RemoveCircle,
        OkCircle,
        BanCircle,
        ArrowLeft,
        ArrowRight,
        ArrowUp,
        ArrowDown,
        ShareAlt,
        ResizeFull,
        ResizeSmall,
        ExclamationSign,
        Gift,
        Leaf,
        EyeOpen,
        EyeClose,
        WarningSign,
        Plane,
        Random,
        Comment,
        Magnet,
        ChevronUp,
        ChevronDown,
        Retweet,
        ShoppingCart,
        FolderClose,
        FolderOpen,
        ResizeVertical,
        ResizeHorizontal,
        Hdd,
        Bullhorn,
        Certificate,
        ThumbsUp,
        ThumbsDown,
        HandRight,
        HandLeft,
        HandUp,
        HandDown,
        CircleArrowRight,
        CircleArrowLeft,
        CircleArrowUp,
        CircleArrowDown,
        Globe,
        Tasks,
        Filter,
        Fullscreen,
        Dashboard,
        HeartEmpty,
        Link,
        Phone,
        Usd,
        Gbp,
        Sort,
        SortByAlphabet,
        SortByAlphabetAlt,
        SortByOrder,
        SortByOrderAlt,
        SortByAttributes,
        SortByAttributesAlt,
        Unchecked,
        Expand,
        CollapseDown,
        CollapseUp,
        LogIn,
        Flash,
        LogOut,
        NewWindow,
        Record,
        Save,
        Open,
        Saved,
        Import,
        Export,
        Send,
        FloppyDisk,
        FloppySaved,
        FloppyRemove,
        FloppySave,
        FloppyOpen,
        CreditCard,
        Transfer,
        Cutlery,
        Header,
        Compressed,
        Earphone,
        PhoneAlt,
        Tower,
        Stats,
        SdVideo,
        HdVideo,
        Subtitles,
        SoundStereo,
        SoundDolby,
        Sound51,
        Sound61,
        Sound71,
        CopyrightMark,
        RegistrationMark,
        CloudDownload,
        CloudUpload,
        TreeConifer,
        TreeDeciduous,
        Briefcase,
        Calendar,
        Pushpin,
        Paperclip,
        Camera,
        Lock,
        Bell,
        Bookmark,
        Fire,
        Wrench
    }

    public enum SimpleIcons
    {
        ActionRedo,
        ActionUndo,
        Anchor,
        ArrowDown,
        ArrowDownCircle,
        ArrowLeft,
        ArrowLeftCircle,
        ArrowRight,
        ArrowRightCircle,
        ArrowUp,
        ArrowUpCircle,
        Badge,
        Bag,
        Ban,
        Basket,
        BasketLoaded,
        Bell,
        BookOpen,
        Briefcase,
        Bubble,
        Bubbles,
        Bulb,
        Calculator,
        Calendar,
        CallEnd,
        CallIn,
        CallOut,
        Camera,
        Camrecorder,
        Chart,
        Check,
        Chemistry,
        Clock,
        Close,
        CloudDownload,
        CloudUpload,
        Compass,
        ControlEnd,
        ControlForward,
        ControlPause,
        ControlPlay,
        ControlRewind,
        ControlStart,
        CreditCard,
        Crop,
        Cup,
        Cursor,
        CursorMove,
        Diamond,
        Direction,
        Directions,
        Disc,
        Dislike,
        Doc,
        Docs,
        Drawer,
        Drop,
        Earphones,
        EarphonesAlt,
        Emotsmile,
        Energy,
        Envelope,
        EnvelopeLetter,
        EnvelopeOpen,
        Equalizer,
        Event,
        Exclamation,
        Eye,
        Eyeglass,
        Feed,
        Film,
        Fire,
        Flag,
        Folder,
        FolderAlt,
        Frame,
        GameController,
        Ghost,
        Globe,
        GlobeAlt,
        Graduation,
        Graph,
        Grid,
        Handbag,
        Heart,
        Home,
        Hourglass,
        Info,
        Key,
        Layers,
        Like,
        Link,
        List,
        LocationPin,
        Lock,
        LockOpen,
        Login,
        Logout,
        Loop,
        MagicWand,
        Magnet,
        Magnifier,
        MagnifierAdd,
        MagnifierRemove,
        Map,
        Menu,
        Microphone,
        Minus,
        Mouse,
        MusicTone,
        MusicToneAlt,
        Mustache,
        Note,
        Notebook,
        Options,
        OptionsVertical,
        Organization,
        PaperClip,
        PaperPlane,
        Paypal,
        Pencil,
        People,
        Phone,
        Picture,
        PieChart,
        Pin,
        Plane,
        Playlist,
        Plus,
        Power,
        Present,
        Printer,
        Puzzle,
        Question,
        Refresh,
        Reload,
        Rocket,
        ScreenDesktop,
        ScreenSmartphone,
        ScreenTablet,
        Settings,
        Share,
        ShareAlt,
        Shield,
        Shuffle,
        SizeActual,
        SizeFullscreen,
        SocialBehance,
        SocialDribbble,
        SocialDropbox,
        SocialFacebook,
        SocialFoursqare,
        SocialGithub,
        SocialGoogle,
        SocialInstagram,
        SocialLinkedin,
        SocialPinterest,
        SocialReddit,
        SocialSkype,
        SocialSoundcloud,
        SocialSpotify,
        SocialSteam,
        SocialStumbleupon,
        SocialTumblr,
        SocialTwitter,
        SocialVkontakte,
        SocialYoutube,
        Speech,
        Speedometer,
        Star,
        Support,
        SymbolFemale,
        SymbolMale,
        Tag,
        Target,
        Trash,
        Trophy,
        Umbrella,
        User,
        UserFemale,
        UserFollow,
        UserFollowing,
        UserUnfollow,
        Vector,
        Volume1,
        Volume2,
        VolumeOff,
        Wallet,
        Wrench
    }

    public class IconAttribute : Attribute
    {
        private string className = null;
        private Glyphicons? glyphicons = null;
        private FontAwesomeIcons? fontawesome = null;
        private SimpleIcons? simpleIcon = null;

        public IconAttribute(string icon)
        {
            this.className = icon;
        }
        public IconAttribute(Glyphicons icon)
        {
            this.glyphicons = icon;
        }
        public IconAttribute(SimpleIcons icon)
        {
            this.simpleIcon = icon;
        }

        public IconAttribute(FontAwesomeIcons icon)
        {
            this.fontawesome = icon;
        }

        public string ClassName()
        {
            if (fontawesome.HasValue)
                return IconHelper.IconClassName(fontawesome.Value);
            else if (simpleIcon.HasValue)
                return IconHelper.IconClassName(simpleIcon.Value);
            else if (glyphicons.HasValue)
                return IconHelper.IconClassName(glyphicons.Value);
            return
                className;
        }
    }


    public class Icon
    {
        private FontAwesomeIcons? IconFontAwesomeIcons;
        public Glyphicons? IconGlyphicons { get; private set; }
        public SimpleIcons? IconSimpleIcons { get; private set; }

        public Icon(FontAwesomeIcons icon)
        {
            IconFontAwesomeIcons = icon;
        }

        public Icon(Glyphicons icon)
        {
            IconGlyphicons = icon;
        }
        public Icon(SimpleIcons icon)
        {
            IconSimpleIcons = icon;
        }

        public static implicit operator Icon(FontAwesomeIcons icon)
        {
            return new Icon(icon);
        }

        public static implicit operator Icon(Glyphicons icon)
        {
            return new Icon(icon);
        }

        public static implicit operator Icon(SimpleIcons icon)
        {
            return new Icon(icon);
        }

        public override string ToString()
        {
            if (IconFontAwesomeIcons.HasValue)
                return IconHelper.IconClassName(IconFontAwesomeIcons.Value);
            else if (IconGlyphicons.HasValue)
                return IconHelper.IconClassName(IconGlyphicons.Value);
            else if (IconSimpleIcons.HasValue)
                return IconHelper.IconClassName(IconSimpleIcons.Value);
            else
                return "";
        }
    }

    public class IconHelper
    {
        public static String IconClassName(FontAwesomeIcons icon)
        {
            return "fa fa-" + Regex.Replace(icon.ToString(), "(\\B[A-Z])", "-$1").ToLower();
        }

        public static String IconClassName(Glyphicons icon)
        {
            return "glyphicon glyphicon-" + Regex.Replace(icon.ToString(), "(\\B[A-Z])", "-$1").ToLower();
        }
        public static String IconClassName(SimpleIcons icon)
        {
            return "icon-" + Regex.Replace(icon.ToString(), "(\\B[A-Z])", "-$1").ToLower();
        }
    }
}